# RegExp class

A regular expression pattern.

Regular expressions are Patterns, and can as such be used to match strings or parts of strings.

Dart regular expressions have the same syntax and semantics as JavaScript regular expressions. See ecma-international.org/ecma-262/5.1/#sec-15.10 for the specification of JavaScript regular expressions.

firstMatch is the main implementation method that applies a regular expression to a string and returns the first Match. All other methods in RegExp can build on it.

Use allMatches to look for all matches of a regular expression in a string.

The following example finds all matches of a regular expression in a string.

    RegExp exp = new RegExp(r"(\w+)");
    String str = "Parse my string";
    Iterable<Match> matches = exp.allMatches(str);

Note the use of a raw string (a string prefixed with `r`) in the example above. Use a raw string to treat each character in a string as a literal character.

Implemented types
  - Pattern

## Constructors

RegExp(String source, { bool multiLine: false, bool caseSensitive: true })
  Constructs a regular expression. [...]
  factory

## Properties

isCaseSensitive → bool
  Whether this regular expression is case sensitive. [...]
  read-only
isMultiLine → bool
  Whether this regular expression matches multiple lines. [...]
  read-only
pattern → String
  The source regular expression string used to create this `RegExp`.
  read-only
hashCode → int
  The hash code for this object. [...]
  read-only, inherited
runtimeType → Type
  A representation of the runtime type of the object.
  read-only, inherited

## Methods

allMatches(String input, [ int start = 0 ]) → Iterable<Match>
  Returns an iterable of the matches of the regular expression on `input`. [...]
  override
firstMatch(String input) → Match
  Searches for the first match of the regular expression in the string `input`. Returns `null` if there is no match.
hasMatch(String input) → bool
  Returns whether the regular expression has a match in the string `input`.
stringMatch(String input) → String
  Returns the first substring match of this regular expression in `input`.
matchAsPrefix(String string, [ int start = 0 ]) → Match
  Match this pattern against the start of `string`. [...]
  inherited
noSuchMethod(Invocation invocation) → dynamic
  Invoked when a non-existent method or property is accessed. [...]
  inherited
toString() → String
  Returns a string representation of this object.
  inherited

## Operators

operator ==(dynamic other) → bool
  The equality operator. [...]
  inherited

## Static Methods

escape(String text) → String
  Returns a regular expression that matches `text`. [...]